% lab10_ex_decim.m - signal decimation
clear all; close all;

L=3; M=50; N=2*M+1; Nx=L*500; nd = 1:200;                % parameters
x = sin(2*pi*(0:Nx-1)/100); figure; plot(x,'o-'); pause  % signal and its plot
h = fir1(N, 1/L - 0.1*(1/L));                            % filter design
xd=filter(h,1,x); % xd = conv(x,h);                      % filtering
xd = xd(1:L:end);                                        % decimation
figure; plot(xd,'o-'); title('xd(n)'); pause             % display result

% DECIMATION: Fast polyphase (PP) implementation - samples to be removed are not computed
% L convolutions of PP components of the original signal and the filter weights
xz = [ zeros(1,L-1) x(1:end-(L-1)) ]; % initial insertion of L-1 preceding zeros 
for k=1:L                             % LOOP START: separate PP filtering
    xdppm(k,:) = filter( h(k:L:end), 1, xz(L-k+1:L:end) ); % k-th PP section
end                                   % LOOP END
xdpp = sum(xdppm);                    % summation of PP components
MaxERR_DECIMpp = max(abs(xd-xdpp)),   % error
figure; plot(nd,xd(nd),'ro-',nd,xdpp(nd),'bx-'); xlabel('n');
title('Decimated signals - slow and fast (PP)'); pause
