% lab10_ex_interp.m - signal interpolation
clear all; close all;

K=5; M=50; N=2*M+1; Nx=200; ni = 1:200;                 % parameters
x = sin(2*pi*(0:Nx-1)/20); figure; plot(x,'o-'); pause  % signal and its plot
xz = zeros(1,K*Nx);                                     % # zero
xz(1:K:end) = x;                                        % # insertion
h = K*fir1(N, 1/K);                                     % filter design
xi = filter(h,1,xz); % xi = conv(xz,h);                 % filtering
figure; plot(xi,'o-'); title('xi(n)'); pause            % display result

% INTERPOLATION: Fast polyphase (PP) implementation - mults by zeros are removed
% K convolutions of PP filter weights with the original signal
xipp = zeros(1,length(x));                        % output initialization
for k=1:K                                         % LOOP START: PP filtering
    xipp(k:K:K*Nx) = filter( h(k:K:end), 1, x );  % k-th PP component filtering
end                                               % LOOP END
MaxERR_INTERPpp = max(abs(xi-xipp)),              % error
figure; plot(ni,xi(ni),'ro-',ni,xipp(ni),'bx-'); grid; xlabel('n');
title('Interpolated signals - slow and fast (PP)'); pause