% lab11_ex_wavelets.m - signal decomposition using wavelet filters 

% Parameters
  niter = 3;          %  decomposition level = number of iterations
  nx = 2^niter*32;    %  length of test signal
  
% LP synthesis filter coefficients h0s, e.g. Db4
  h0s = [ (1+sqrt(3))/(4*sqrt(2)) (3+sqrt(3))/(4*sqrt(2)) ...
          (3-sqrt(3))/(4*sqrt(2)) (1-sqrt(3))/(4*sqrt(2)) ];
% Calculate remaining filters
  N = length(h0s); n = 0:N-1;
  h1s = (-1).^n .* h0s(N:-1:1);        % HP synthesis filter
  h0a = h0s(N:-1:1); h1a=h1s(N:-1:1);  % LP and HP analysis filters
  
% Synthesis of "approximation" wavelets - given
% Synthesis of "detail" wavelets - your homework!
  c = 1;
  for m = 1:10                         % synthesis levels
      c0=[];  
      for k = 1:length(c)
          c0(2*k-1)=c(k); c0(2*k)=0;   % 2-time expander
      end
      c = conv(c0,h0s);                % LP wavelet filter 
  end
  figure; plot( c ); title('Approximation function/wavelet'); pause
  
% Test signal
% x=sin(2*pi*(1:nx)/32);
  x=rand(1,nx);
  
% Wavelet analysis, discrete wavelet transform
  cc = x;  
  for m = 1:niter
     c0 = conv(cc,h0a);                % LP filtration
     d0 = conv(cc,h1a);                % HP filtration
     k=N:2:length(d0)-(N-1); kp=1:length(k); ord(m)=length(kp); dd(m,kp) = d0( k );
     k=N:2:length(c0)-(N-1); cc=c0( k );
  end
  
% Wavelet synthesis, inverse discrete wavelet transform
  c=cc;
  for m = niter:-1:1
      c0=[]; d0=[];  
      for k = 1:length(c)
          c0(2*k-1)=c(k); c0(2*k)=0;         % 2-times expander
      end
      c = conv(c0,h0s); nc=length(c);        % LP wavelet filter
      for k = 1:ord(m)
          d0(2*k-1) = dd(m,k); d0(2*k) = 0;  % 2-times expander
      end
      d = conv(d0,h1s); nd=length(d);        % HP wavelet filter
      c = c(1:nd);
      c = c + d; 
  end
  
% Final figures
  n = 2*(N-1)*niter : length(c)-2*(N-1)*niter+1;
  figure; plot(x); title('Input signal'); pause
  figure; plot(n,c(n)-x(n)); title('Output signal - Input signal'); pause